import java.io.*;
import java.util.*;
import ddf.minim.*;
Minim minim, minim2, minim3, minim4;
AudioSample shutter, beep, bleep, intro;

import processing.video.*;
import processing.serial.*;
Capture cam;
Serial myPort;

PImage graphics;

int photoIndex = 0;
int u = 255;

static String dictionaryPath = "/Users/interaction/Documents/Processing/Smile_picture/";
static String fileEnding = ".png";
static int photoDisplayRefreshRateInMilliseconds = 400;

static int timeOfLastSoundInMilliSeconds = 300000;


FilenameFilter imageFilter;
TreeSet<Photo> photos = new TreeSet();
Date dateOfLastPhotoRefresh = new Date();

Date timeOfLastSoundPlay = new Date();

boolean recording = false;

int[] origin = new int[1024];
int[] comparison = new int[1024];

int index = 100;
int i = 0;

// Timer

PFont font;
String time = "5";
int t = 6;
int lastT = 7;
int interval = 5;
int newTime = 0;
int oldTime = 0;

// End timer

boolean sketchFullScreen() {
  return true;
}

void setup() {
//  size(640, 360);
  size(1024, 768);
  font = createFont("Arial", 30, true);
  textFont(font,height/2);
  graphics = loadImage("workingfiles/logo.png");
  
// Load sound  
  minim = new Minim(this);
  minim2 = new Minim(this);
  minim3 = new Minim(this);
  minim4 = new Minim(this);
  shutter = minim.loadSample("shutter.wav");
  beep = minim2.loadSample("beep.wav");
  bleep = minim4.loadSample("bleep.wav");
  intro = minim3.loadSample("intro.wav");

// End sound  
  
  smooth();
  
  String[] cameras = Capture.list();
  
  if (cameras.length == 0){
    println("There are no cameras available for capture.");
    exit();
  } else {
    println("Available cameras:");
    for (int i = 0; i < cameras.length; i++) {
      println(cameras[i]);
    }
    
    //cam = new Capture(this, width, height, "USB2.0_Camera #2");
    cam = new Capture(this, cameras[0]);
    cam.start();

  }


imageFilter = new FilenameFilter() {
    public boolean accept(File dir, String name) {
      return name.toLowerCase().endsWith(fileEnding);
    }
  };
  
  // Load the photos the first time when the app starts
  loadJPGFilesInFolder();
  
  // PRINTER
  
  // List all the available serial ports
println(Serial.list());
// I know that the first port in the serial list on my mac
// is always my  Keyspan adaptor, so I open Serial.list()[0].
// Open whatever port is the one you're using.
myPort = new Serial(this, Serial.list()[0], 9600);
myPort.clear();
// Throw out the first reading, in case we started reading 
// in the middle of a string from the sender.
  
  intro.trigger();
  
}



void draw() {
  
if(recording == false){  
  
  // Make sure that scan our folder for new photos every few seconds
  
  if (shouldDisplayNewPhoto()) {
  // background(0);
    updatePhoto(photoIndex++);
    dateOfLastPhotoRefresh = new Date();
  }
  
  // int randomIntro = int(random(43));
  
  // if(randomIntro == 42){
  if(shouldLoadSound()){
    intro.trigger();
    timeOfLastSoundPlay = new Date();
  }
  //}
  
}
   
  else{
    
// Initiate the picture process if the button is pushed.
    
//  if (recording) {
  
    if (cam.available() == true) {
    cam.read();
    }
    imageMode(CORNER);
    image(cam, 0, 0, width, height);
    
    // println("Inside");
    
    if(t < 0){
    oldTime = millis();
    }
    fill(255);
    newTime = millis()-oldTime;
    t = interval-(newTime/1000);
    time = nf(t , 1);
    textAlign(CENTER, CENTER);
    
    if(t <= 5 && t > 0){
    text(time, width/2, height/2);
    }
    
    if(lastT != t && t <= 3 && t > 0){
    bleep.trigger();
    }
    lastT = t;
    
//  println("Outside");
//  println("interval: " + interval);
//  println("oldTime: " + oldTime);
//  println("newTime: " + newTime);
//  println("t: " + t);
      
    if(t == -1){
      if (cam.available() == true) {
    cam.read();
    }
      image(cam, 0, 0, width, height);
      delay(30);
      
      saveFrame("/Users/interaction/Documents/Processing/Smile_picture/Smile_" + day() + month() + year() + "_" + hour() + minute() + second() + ".png");

      shutter.trigger();
      recording = !recording;
      
      t = 4;
      loadJPGFilesInFolder();
    }
//  } record brackett
  
  //fill(255);
  /*  
  // A red dot for when we are recording
  stroke(255);
  if (recording) fill(255, 0, 0);
  else noFill();
  ellipse(width/2, height-48, 16, 16);
*/
  }

imageMode(CORNER);
image(graphics, 0, 0, width, height);

}


void keyPressed() { // Trigger the device.
  if (key == 'w' || key == 'W') {
    if(!recording){  
      beep.trigger();
      recording = true;
      myPort.write('0');  
  }
  }
  
}


void stop()
{
  // the AudioPlayer you got from Minim.loadFile()
  // the AudioInput you got from Minim.getLineIn()
  shutter.close();
  beep.close();
  intro.close();
  minim.stop();
 
  // this calls the stop method that 
  // you are overriding by defining your own
  // it must be called so that your application 
  // can do all the cleanup it would normally do
  super.stop();
}


void compare(){
  
  // Read the screen and load into origin.
  for(int x = 0; x<1024; x++) {
   for(int y = 0; y<1; y++) {
     origin[i] = get(x,y);
     i += 1;
   }
 }
 i = 0;
 
// Compare to the old comparison image.
 for(i=0; i<1024; i++){
 if(origin[i] < comparison[i]+250000 && origin[i] > comparison[i]-250000){
   index += 1;
   // println("index: " + origin[i]);
} }

println("index: " + index);
index = 0;

i = 0;

// load the origin into the comparison file.

 for(i=0; i<1024; i++){
 comparison[i] = origin[i];
 }
 i = 0;
 
}


void loadJPGFilesInFolder() {
  File folder = new File(dataPath(dictionaryPath));
  String[] filenames = folder.list(imageFilter);
  
  if (filenames == null) {
    println("Couldn't find any files in the specified folder");
    return;
  }
 
  int numberOfFilesFound = filenames.length;
  println(numberOfFilesFound + " jpg files in specified directory");
    
  // display the filenames
  for (int i = 0; i < filenames.length; i++) {
    String filename = filenames[i];
    
    File imageFile = new File(dataPath(dictionaryPath) + "/" + filename);
    println("Loading image " + filename + ", last changed on " + imageFile.lastModified());
    PImage image = loadImage(filename);
    
    Photo photo = new Photo(image, imageFile.lastModified(), filename);
    photos.add(photo);
  }
}

/*void updatePhotos() {
  Photo[] photoArray = photos.toArray(new Photo[photos.size()]);
  int randomPhotoIndex = (int)random(0, photoArray.length - 1);
  Photo photo = photoArray[randomPhotoIndex];
  photo.display();
}*/
void updatePhoto(int index) {
 Photo[] photoArray = photos.toArray(new Photo[photos.size()]);
 int wrappingIndex = index % photoArray.length;
 Photo photo = photoArray[wrappingIndex];
 photo.display();
}

boolean shouldDisplayNewPhoto() {
  Date now = new Date();
  return (now.getTime() - dateOfLastPhotoRefresh.getTime() >= photoDisplayRefreshRateInMilliseconds);
}

boolean shouldLoadSound() {
  Date now = new Date();
  return (now.getTime() - timeOfLastSoundPlay.getTime() >= timeOfLastSoundInMilliSeconds);
}

class Photo implements Comparable<Photo> {
 PImage photo;
 float alpha = 1;
 long lastChanged;
 boolean fadedIn = false;
 String filename;

 Photo(PImage image, long lastChangedMillis, String path) {
   photo = image;
   lastChanged = lastChangedMillis;
   filename = path;
 }

 void display() {
   rectMode(CENTER);
   imageMode(CENTER);
   noStroke();
   //fadeIn(2);
   image(photo, width/2.0, height/2.0, width, height);
   //noTint();
 }
 
  public int hashCode() {
    return filename.hashCode();
  }

  public boolean equals(Object obj) {
    return this.hashCode() == obj.hashCode();
  }
 
 String toString() {
   return "Last Changed" + lastChanged;
 }
 
 public int compareTo(Photo object) {
  if (lastChanged < object.lastChanged)
    return 1;
  else if (lastChanged > object.lastChanged)
    return -1;
  return 0;
 }

}
